
----------------------------------------------------------------------------------------------------------------
-- global variables

time_main_music = 0
time_quiet_music = 0

is_player_in_water = false

sound_splash = 0

model_selecter = 0
model_selecter2 = 0

mode_build = 0

sprite_wood_icon = 0
sprite_gold_icon = 0

sprite_help_is_enabled = true
sprite_mission = 0
sprite_help_mission = 0

sprite_red_cross = 0

wood_stock = 10
gold_stock = 10

next_time_redo = 0

mission = 1

sprite_empty_for_text = 0

----------------------------------------------------------------------------------------------------------------
-- load and save

function callSaveGame()
	saveGame()
	scheduleDraw2DSprite('images/empty_for_text.png', 1000)
	scheduleDrawTextCenter('Game saved.', 1000)
	next_time_redo = getTime() + 1000
end

function callLoadGame()
	loadGame()
	is_game_over = 0
	is_player_in_water = false
	next_time_redo = getTime() + 1000
end

----------------------------------------------------------------------------------------------------------------

model_Inhabitant = 0

Inhabitant = {

	load = function()
		model_Inhabitant = load3DModel('models/obj_player_robot/player_frame1.obj')
	end,
	
	init = function()
	end,

	manage = function()
		if getDistanceToPlayer() < 15 and getTime() > next_time_redo and not isEditorMode() then
			scheduleDraw2DSprite('images/empty_for_text.png', 1000)
			scheduleDrawTextCenter('Hello. Maybe you can help me.\nThere is a power plant near there \nand I try to build cables to \nreach it.', 1000)
			next_time_redo = getTime() + 3000
		end
	end,

	draw = function()
		draw3DModel(model_Inhabitant)
	end,
	
	uninit = function()
	end,

	unload = function()
		unload3DModel(model_Inhabitant)
	end
}

----------------------------------------------------------------------------------------------------------------

model_Gun = 0
pos_gun_x = 0
pos_gun_y = 0

Gun = {

	load = function()
		model_Gun = load3DModel('models/obj_gun/gun.obj')
	end,
	
	init = function()
	end,

	manage = function()
		if getDistanceToPlayer() < 15 and getTime() > next_time_redo and not isEditorMode() then
			local win_width, win_height = getWindowSize()
			callSaveGame()
			mission = mission + 1
			unload2DSprite(sprite_mission)
			unload2DSprite(sprite_help_mission)
			sprite_mission = load2DSprite('images/mission2.png')
			sprite_help_mission = load2DSprite('images/help_mission2.png')
			autoDestroyCurrentObject()
			scheduleDraw2DSprite('images/empty_for_text.png', 3000)
			scheduleDrawTextCenter('Congratulations !\nYou found the dig gun.', 3000)
			
			--scheduleDraw2DSprite('images/congratulations_mission1.png', win_width/2-128, win_height/2-64, 3000)
			pos_gun_x = - 100
			pos_gun_y = - 100
		else
			pos_gun_x, pos_gun_y = get2DPosFrom3D(getCurrentObjectPosition())
		end
		
	end,

	draw = function()
		draw3DModel(model_Gun)
	end,
	
	uninit = function()
	end,

	unload = function()
		unload3DModel(model_Gun)
	end
}

----------------------------------------------------------------------------------------------------------------

MagicSphere = {

	model_magic_sphere = 0,

	load = function() model_magic_sphere = load3DModel('models/obj_magic_sphere/magic_sphere.obj') end,
	
	init = function()
	end,
	
	manage = function()
		if getDistanceToPlayer() < 15 and getTime() > next_time_redo and not isEditorMode() then
			callSaveGame()
		end
	end,
	
	draw = function()
		if getTime() > next_time_redo then
			draw3DModel(model_magic_sphere)
		end
	end,
	
	uninit = function()
	end,
	
	unload = function()
		unload3DModel(model_magic_sphere)
	end
}

----------------------------------------------------------------------------------------------------------------

model_Pipe = 0
Pipe = {

	load = function()
		model_Pipe = load3DModel('models/obj_pipe/pipe.obj')
	end,
	
	init = function()
		x,y,z = getCurrentObjectPosition()
		addSegmentInGraph(x,y,z-15, x,y,z+15)
	end,

	manage = function()
	end,

	draw = function()
		draw3DModel(model_Pipe)
	end,
	
	uninit = function()
		x,y,z = getCurrentObjectPosition()
		removeSegmentFromGraph(x,y,z-15, x,y,z+15)
	end,

	unload = function()
		unload3DModel(model_Pipe)
	end
}

----------------------------------------------------------------------------------------------------------------
model_Path1 = 0

Path1 = {

	load = function()
		model_Path1 = load3DModel('models/obj_path/path1.obj')
	end,
	
	init = function()
		x,y,z = getCurrentObjectPosition()
		addSegmentInGraph(x,y,z-5, x,y,z+5)
	end,

	manage = function()
	end,

	draw = function()
		draw3DModel(model_Path1)
	end,
	
	uninit = function()
		x,y,z = getCurrentObjectPosition()
		removeSegmentFromGraph(x,y,z-15, x,y,z+15)
	end,

	unload = function()
		unload3DModel(model_Path1)
	end
}
----------------------------------------------------------------------------------------------------------------
model_Path2 = 0

Path2 = {

	load = function()
		model_Path2 = load3DModel('models/obj_path/path2.obj')
	end,
	
	init = function()
		x,y,z = getCurrentObjectPosition()
		addSegmentInGraph(x,y,z-5, x,y,z+5)
	end,

	manage = function()
	end,

	draw = function()
		draw3DModel(model_Path2)
	end,
	
	uninit = function()
		x,y,z = getCurrentObjectPosition()
		removeSegmentFromGraph(x,y,z-15, x,y,z+15)
	end,

	unload = function()
		unload3DModel(model_Path2)
	end
}

----------------------------------------------------------------------------------------------------------------
model_DormRoom = 0

DormRoom = {

	load = function()
		model_DormRoom = load3DModel('models/obj_dorm_room/dorm_room.obj')
	end,

	init = function()
	end,

	manage = function()
	end,

	draw = function()
		draw3DModel(model_DormRoom)
	end,
	
	uninit = function()
	end,
	
	unload = function()
		unload3DModel(model_DormRoom)
	end
}

----------------------------------------------------------------------------------------------------------------
model_Market = 0

Market = {

	load = function()
		model_Market = load3DModel('models/obj_market/market.obj')
	end,

	init = function()
	end,

	manage = function()
	end,

	draw = function()
		draw3DModel(model_Market)
	end,
	
	uninit = function()
	end,
	
	unload = function()
		unload3DModel(model_Market)
	end
}

----------------------------------------------------------------------------------------------------------------

Game = {

	sound_main_music = 0,
	model_delta_wing = 0,

	--------------------------------------------------------

	init = function()
		setFogColor(180,200,255)
		sound_main_music = loadSound('sound/ocean.ogg')		
		fall_in_water_sprite = load2DSprite('images/fall_in_water.png')
		model_delta_wing = load3DModel('models/obj_delta_wing/delta_wing.obj')
		time_main_music = getTime()
		time_quiet_music = getTime() + 120000 --120 seconds
		initActiveObjects('Gun','MagicSphere','Inhabitant','Pipe','Path1','Path2','DormRoom','Market')
		--setPlayerPositionReal(5640, 320, 20)
		setPlayerPositionReal(0, 1000.0, 0)
		--callLoadGame()
		model_selecter = load3DModel('models/obj_selecter/selecter.obj')
		model_selecter2 = load3DModel('models/obj_selecter/selecter2.obj')
		sprite_wood_icon = load2DSprite('images/wood_icon.png')
		sprite_gold_icon = load2DSprite('images/gold_icon.png')
		sprite_red_cross = load2DSprite('images/red_cross.png')
		sprite_mission = load2DSprite('images/mission1.png')
		sprite_help_mission = load2DSprite('images/help_mission1.png')
		sprite_empty_for_text = load2DSprite('images/empty_for_text.png')
		--setPlayerMovementCar();
	end,
	
	--------------------------------------------------------

	uninit = function()
		unload2DSprite(fall_in_water_sprite)
		unload2DSprite(sprite_wood_icon)
		unload2DSprite(sprite_gold_icon)
		unload2DSprite(sprite_red_cross)
		unload2DSprite(sprite_mission)
		unload2DSprite(sprite_help_mission)
		unload2DSprite(sprite_empty_for_text)
		unload3DModel(model_delta_wing)
		unload3DModel(model_selecter)
		unload3DModel(model_selecter2)
	end,
	
	--------------------------------------------------------
	
	manage = function()
	
		if getTime() > time_main_music then
			time_main_music = getTime() + 500000
			---playSound(sound_main_music)
			---setSoundVolume(sound_main_music, 0.0)
		end
		
		local xpl,ypl,zpl = getPlayerPositionReal()
		if ypl > 300.0 then --and isPlayingSound(sound_main_music) 
			---setSoundVolume(sound_main_music, 0.0)
		else
			---setSoundVolume(sound_main_music, 1.0 - ypl/300.0)
			--setSoundVolume(sound_main_music, 0.0)
		end
		
		if getTime() > time_quiet_music then
			time_quiet_music = getTime() + 500000
			--playSound(sound_quiet_music)
		end
		
		if getKeyNoRepeat('a') then
			setEditorMode(not isEditorMode())
		end
	
	end,
	
	--------------------------------------------------------
	
	draw3D = function()
	
		if not isEditorMode() then
		
			x, y, z = getPlayerPositionReal()
			
			-- fall into the water
			if y < -0.0 and not is_player_in_water then
				--playSound(sound_splash)
				is_player_in_water = true
			end
			
			if getKey('l') then
				callLoadGame()
			end
			
			-- flying
			if getKey('r') then
				speedx, speedy, speedz = getPlayerSpeed()
				setPlayerSpeed(speedx, 1.0, speedz)
			end
			
			-----------------
			-- get mouse infos
			
			local is_left_click, is_middle_click, is_right_click, is_wheel_up, is_wheel_down, pos_x, pos_y = getMouseInfos()
			
			if getKeyNoRepeat('ASCII:9') or is_wheel_up then -- tab
				mode_build = mode_build + 1
				if mode_build > 5 then
					mode_build = 0
				end
			elseif is_wheel_down then
				mode_build = mode_build - 1
				if mode_build < 0 then
					mode_build = 5
				end
			end
			
			-----------------
			-- get selecter position
			
			local angle_x, angle_y, dist = getCameraAngleAndDistance()
			local is_on_z = ((angle_y>45 and angle_y<135) or (angle_y>-135 and angle_y<-45))
			if mode_build == 1 then
				angle_x = angle_x + 45
			else
				angle_x = 0
			end
			local x, y, z = cartesianCoordFromSphericalCoord(angle_x,angle_y, 12.0)
			local xpl, ypl, zpl = getPlayerPositionReal()
			local selecter_pos_x = math.floor((x+xpl)/10)
			local selecter_pos_y = math.floor((y+ypl)/10)
			local selecter_pos_z = math.floor((z+zpl)/10)

			if mode_build == 0 then
			
				if is_left_click then
					speedx, speedy, speedz = getPlayerSpeed()
					if speedy < -0.0 then
						setCurrentPositionReal(getPlayerPositionReal())
						local angle_x, angle_y, dist = getCameraAngleAndDistance()
						rotatePosition(0,angle_y,0)
						draw3DModel(model_delta_wing)
						if speedx > 0.0 then
							setPlayerSpeed(6.0, -0.2, speedz)
						else
							setPlayerSpeed(speedx, -0.2, speedz)
						end
					end
				end
				
			elseif mode_build == 1 or mode_build == 2 then
				
				setCurrentPosition(selecter_pos_x, selecter_pos_y, selecter_pos_z)
				
				local cube_type1 = getCubeTypeAt(selecter_pos_x,selecter_pos_y,selecter_pos_z)
				local cube_type2 = getCubeTypeAt(selecter_pos_x,selecter_pos_y+1,selecter_pos_z)
				
				if mode_build == 1 then
					draw3DModel(model_selecter)
				else
					draw3DModel(model_selecter2)
				end
				
				if is_left_click then
					if cube_type1 ~= -1 then
						gold_stock = gold_stock - 1
						if cube_type1 == 4 then
							gold_stock = gold_stock + 10
						end
					end
					if mode_build == 2 and cube_type2 ~= -1 then
						gold_stock = gold_stock - 1
						if cube_type2 == 4 then
							gold_stock = gold_stock + 10
						end
					end
					if cube_type1 ~= -1 or (mode_build == 2 and cube_type2 ~= -1) then
						removeCubeParallelepiped(
							selecter_pos_x,selecter_pos_y,selecter_pos_z,
							selecter_pos_x+1,selecter_pos_y+mode_build,selecter_pos_z+1)
					end
				elseif is_middle_click then
					if cube_type1 == -1 then
						wood_stock = wood_stock - 1
						gold_stock = gold_stock - 1
					end
					if mode_build==2 and cube_type2 == -1 then
						wood_stock = wood_stock - 1
						gold_stock = gold_stock - 1
					end
					if cube_type1 == -1 or (mode_build==2 and cube_type2 == -1) then
						createCubeParallelepiped(
							selecter_pos_x,selecter_pos_y,selecter_pos_z,
							selecter_pos_x+1,selecter_pos_y+mode_build,selecter_pos_z+1,2)
					end
				end
			
			elseif mode_build == 3 then
			
				if is_on_z then
					local is_void = isVoid(selecter_pos_x,selecter_pos_y,selecter_pos_z,0,0,-1,0)
					if is_left_click and is_void and getObjectTypeAt(selecter_pos_x*10+5, selecter_pos_y*10, selecter_pos_z*10) == '' then
						createObject(selecter_pos_x*10+5, selecter_pos_y*10, selecter_pos_z*10, 'Path1', 1)
					end
				else
					local is_void = isVoid(selecter_pos_x,selecter_pos_y,selecter_pos_z,-1,0,0,0) 
					if is_left_click and is_void and getObjectTypeAt(selecter_pos_x*10, selecter_pos_y*10, selecter_pos_z*10+5) == '' then
						createObject(selecter_pos_x*10, selecter_pos_y*10, selecter_pos_z*10+5, 'Path2', 1)
					end
				end
				
			elseif mode_build == 4 then
			
				local is_a_room = isARoom(selecter_pos_x,selecter_pos_y,selecter_pos_z)
				if is_left_click and getObjectTypeAt(selecter_pos_x*10, selecter_pos_y*10, selecter_pos_z*10) == '' then
					createObject(selecter_pos_x*10, selecter_pos_y*10, selecter_pos_z*10, 'DormRoom', 1)
				end
				
			elseif mode_build == 5 then
			
				local is_void = isVoid(selecter_pos_x,selecter_pos_y,selecter_pos_z,-2,1,-2,1)
				if is_left_click and getObjectTypeAt(selecter_pos_x*10, selecter_pos_y*10, selecter_pos_z*10) == '' then
					createObject(selecter_pos_x*10, selecter_pos_y*10, selecter_pos_z*10, 'Market', 1)
				end
			end
			
			--if getKey('s') then
			--	local xpl, ypl, zpl = getPlayerPositionReal()
			--	startCubeCreation(xpl,ypl,zpl)
			--end
			
			--local is_finished, x1,y1,z1,x2,y2,z2 = manageCubeCreation()
		end
	end,
	
	--------------------------------------------------------
	
	draw2D = function()
	
		local win_width, win_height = getWindowSize()

		if not isEditorMode() then
				
			--draw2DSprite(sprite_wood_icon, 10, 10)
			--drawText(""..wood_stock, 50,10)
			
			--draw2DSprite(sprite_gold_icon, 90, 10)
			--drawText(""..gold_stock, 130,10)
			
			--	drawText('For main commands, press Esc. Additional test commands:\nt: throw explosive sphere\ni: delete cube\nr: fly', 10, 30)
			
			if is_player_in_water then
				setPlayerMovementNone()
				setColor(255,255,255,255)
				if not isEditorMode() then
					draw2DSprite(fall_in_water_sprite, win_width/2 - 128, win_height/2 - 128)
				end
				local px,py,pz = getPlayerPositionReal()
				setPlayerPositionReal(px, -10.0, pz)
			end
			
			if getKeyNoRepeat('h') then
				sprite_help_is_enabled = not sprite_help_is_enabled
			end
			
			if sprite_help_is_enabled then
				draw2DSprite(sprite_help_mission, 10, win_height - 256)
			else
				draw2DSprite(sprite_mission, 10, win_height - 80)
			end
		
		--	drawText( findPathInGraph(0,10,-5,0,10,80), 10,10)
			--drawText( ''..pos_gun_x..', '..pos_gun_y, 10, 30)
			draw2DSprite(sprite_red_cross, pos_gun_x-16, pos_gun_y-16)
		end
	end
}

----------------------------------------------------------------------------------------------------------------

function isVoid(selecter_pos_x,selecter_pos_y,selecter_pos_z, xmin,xmax,zmin,zmax)
	local i,j,k
	local failed = false
	for i = xmin, xmax, 1 do 
		for j = -1, 1, 1 do 
			for k = zmin, zmax, 1 do 
				if j == -1 then -- the ground
					if getCubeTypeAt(selecter_pos_x+i,selecter_pos_y+j,selecter_pos_z+k) == -1 then
						failed = true
					end
				else
					if j == 0 then
						setCurrentPosition(selecter_pos_x+i, selecter_pos_y+j, selecter_pos_z+k)
						draw3DModel(model_selecter2)
					end
					if getCubeTypeAt(selecter_pos_x+i,selecter_pos_y+j,selecter_pos_z+k) > -1 then
						failed = true
					end
				end
			end
		end
	end
	return (not failed)
end

function isARoom(selecter_pos_x,selecter_pos_y,selecter_pos_z)
	local i,j,k
	local failed = false
	local nb_of_apertures = 0
	for i = -3, 2, 1 do 
		for j = -1, 2, 1 do 
			for k = -3, 2, 1 do 
				if i == -3 or i == 2 or j == -1 or j == 2 or k == -3 or k == 2 then -- the wall of the room
					if getCubeTypeAt(selecter_pos_x+i,selecter_pos_y+j,selecter_pos_z+k) == -1 then
						nb_of_apertures=nb_of_apertures+1
					end
				else --inside the room
					if j == 0 then
						setCurrentPosition(selecter_pos_x+i, selecter_pos_y+j, selecter_pos_z+k)
						draw3DModel(model_selecter2)
					end
					if getCubeTypeAt(selecter_pos_x+i,selecter_pos_y+j,selecter_pos_z+k) > -1 then
						failed = true
					end
				end
			end
		end
	end
	if (not failed) and (nb_of_apertures < 8) then -- max 8 holes in the wall
		return true
	end
	return false
end
